include get.e
include graphics.e

-------------------------------------------
-- Display a prompt and receive a string --
-------------------------------------------
global function get_string(sequence prompt)
-- make this functions global to all your programs
-- by putting it in your own 'myheader.e' file
sequence in_string              -- to read in the input
    puts(1, prompt)             -- put prompt (question) on the screen
    in_string = gets(0) -- read string input from the keyboard
    puts(1, '\n')               -- to start on a new line when back from function
	-- return the input string now, but strip off the last character,
	-- since that is a 'new line' character (ASCII 10)
    return in_string[1..length(in_string) - 1]
end function    -- prompt_in()

---------------------------------------------
-- Display a prompt and receive an integer --
---------------------------------------------
global function get_number(sequence prompt)
-- print a message and read in a number
-- returns the number, that can either be an integer or an atom(float)
sequence input, curpos
    input = {1, 0}              -- this initializes the variable input with
				-- values that are *not* valid
    puts(1, prompt)             -- put message on screen
    while input[1] do           -- repeat until valid number
	curpos = get_position() -- read current cursor position
	input = get(0)          -- read from the keyboard
	position(curpos[1], curpos[2])  -- back to position if not valid
    end while
    puts(1, '\n')               -- to start on a new line when back from function
    return input[2]             -- the second element of input is returned and                             -- should contain a valid number
end function    -- input()

--------------------------------------------
--       Change 4.37 into 4 and .37       --
--------------------------------------------
global function cut(atom x) -- return {trunc, frac}
   atom t
   if x<0 then
      x=-x
      t=floor(x)
      return -{t,x-t}
   else
      t=floor(x)
      return {t,x-t}
   end if
end function

-------------------------------------------
-- Strip all whitespace from a string    --
-------------------------------------------
global function nospace(sequence s1)
        sequence s2
        atom space, n, x, y
        space = 1
        n = 0

        while space != 0 do
                space = match(" ", s1)
                        if space = 0 then
                                return{s1}
                        else
                                        n = space - 1
                                        s2 = s1[1..n]
                                        x = space + 1
                                        y = length(s1)
                                        s1 = s2 & s1[x..y]
                        end if
        end while
        return{s1}
end function

--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Load Text File into Memory
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

global function load_text(sequence fname)
   atom fn
   object line
   sequence file
   
   fn = open(fname, "r")
   file = {}
   while 1 do
        line = gets(fn)
        if atom(line) then
                exit
        end if
        file = append(file, line)
   end while
   close(fn)
   return(file)
end function
